<?php
  
class Brivium_ThreadInactivity_CronEntry_Action
{
	
	public static function runDaily()
	{
		
		$db = XenForo_Application::getDb();
		$options = XenForo_Application::get('options');
		$model = new XenForo_Model_Thread;
		

		$forum = $options->ThreadInactivity_forum;

		if(implode(",", $forum) == 0)
		{
			$forums = '';
		}
		else
		{
			$forums = ' AND node_id IN ('.implode(",", $forum).')';
		}

		$close = $options->ThreadInactivity_close;
		$delete = $options->ThreadInactivity_delete;
		$move = $options->ThreadInactivity_move;

	    if(!empty($close['enabled']))
		{
	    	$db->update('xf_thread', array('discussion_open' => 0), 'last_post_date < ' . (XenForo_Application::$time - $close['days']*60*60*24) . $forums);
	    }

	    if(!empty($delete['enabled']))
		{
			$threadIds = $db->fetchCol('SELECT thread_id FROM xf_thread WHERE last_post_date < ' . (XenForo_Application::$time - $delete['days']*60*60*24)  . $forums);

			$hardDelete = $delete['hardDelete'];
			$deleteType = ($hardDelete ? 'hard' : 'soft');
			$options = array();

			foreach ($threadIds as &$threadId) 
			{
				$model->deleteThread($threadId, $deleteType, $options);
			}
	    }
	    
	    if(!empty($move['enabled']) && !empty($move['archive']))
		{
			$threadIds = $db->fetchCol('SELECT thread_id FROM xf_thread WHERE last_post_date < ' . (XenForo_Application::$time - $move['days']*60*60*24)  . $forums);

			foreach ($threadIds as &$threadId) 
			{
				$dw = XenForo_DataWriter::create('XenForo_DataWriter_Discussion_Thread');
				$dw->setExistingData($threadId);
				$dw->set('node_id', $move['archive']);
				$dw->save();
			}
	    }
	}
	
}